#ifndef TDE_WIDGETS_LABEL_H
#define TDE_WIDGETS_LABEL_H

#include <QWidget>
#include <QLabel>
#include <QTimer>

#include "common.h"
#include "opaque.h"

// -- TDE NAMESPACE ----------------------------------------------------

namespace TDE {

// -- Widgets NAMESPACE ------------------------------------------------

namespace Widgets {

/*!
 * \class Label
 * \brief Widget for displaying DataStore variables as labels.
 *
 * \see DataStore
 * \see WidgetInfo
 */
class Label : public QLabel
{
    Q_OBJECT
	Q_PROPERTY(QString variableName READ variableName WRITE setVariableName NOTIFY variableChanged)
    Q_PROPERTY(bool trace READ trace WRITE setTrace NOTIFY traceChanged)
    Q_PROPERTY(int refresh READ refresh WRITE setRefresh NOTIFY refreshChanged)
    Q_PROPERTY(bool raw READ raw WRITE setRaw NOTIFY rawChanged)
    Q_PROPERTY(bool descriptionAppend READ descriptionAppend WRITE setDescriptionAppend)
    Q_PROPERTY(bool descriptionPrepend READ descriptionPrepend WRITE setDescriptionPrepend)
    Q_PROPERTY(QString nativeUnit READ nativeUnit)
    Q_PROPERTY(QString displayUnit READ displayUnit WRITE setDisplayUnit NOTIFY displayUnitChanged)

public:
    Label(QWidget *parent = 0);
    virtual ~Label();

    SHARED_PTR<TDE::DataStore> dataStore();
    Label& setDataStore(SHARED_PTR<TDE::DataStore> ds_p);
    Label& setVariableName(const std::string& name);

    int     variableIndex() const;
    const TDE::VariableDescr& variableDescr() const;

    // properties getters/setters

    QString variableName() const;
    void    setVariableName(const QString&);

    bool trace() const;
    bool setTrace(bool value = true);

    int refresh() const;
    int setRefresh(int value = 0);

    QString nativeUnit() const;
    QString displayUnit() const;
    void    setDisplayUnit(const QString& value);

    TDE::DisplayUnitPtr nativeUnitPtr() const;
    TDE::DisplayUnitPtr displayUnitPtr() const;

    bool raw() const;
    bool setRaw(bool value = true);

    bool setDescriptionAppend(bool value = true);
    bool descriptionAppend() const;
    bool setDescriptionPrepend(bool value = true);
    bool descriptionPrepend() const;

signals:
    void variableChanged(QString);
    void integerVariableValueChanged(int);
    void floatVariableValueChanged(float);
    void traceChanged(bool);                // trace option changed
    void refreshChanged(int);               // refresh value changed
    void rawChanged(bool);                  // raw option changed
    void displayUnitChanged(QString);       // display unit changed
    void labelClicked(TDE::Widgets::Label*, int);				// mouse pressed on label name...

public slots:
    void ui2ds();    // set DataStore variable with value from UI
    void ds2ui();    // set UI with value from DataStore
    void showTooltip();   //show Tooltip delayed

private:
	SHARED_PTR<WidgetInfo> m_winfo;
    QTimer *m_multiView;
    QString dbStr;
    QString originalTip;
    int mask_bit;

protected:
    virtual void showEvent(QShowEvent *event);
    virtual void mouseReleaseEvent(QMouseEvent* e);
    virtual void mousePressEvent(QMouseEvent* e);
    SHARED_PTR<WidgetInfo> widgetInfo() { return m_winfo; }

    friend class UnitLabel;
};

} /* end of namespace Widgets */

} /* end of namespace TDE */

#endif /* TDE_WIDGETS_LABEL_H */
